//
//  AGSegmentedControlStyles.h
//  AGSegmentedControl
//
//  Created by Seth Willits on June 30, 2007.
//  Copyright 2007 Araelium Group. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@class AGSegmentedControl, AGSegmentedCell;
@protocol AGSegmentedStyleDelegateMethods <NSObject>

// Optional
- (NSSize)desiredSizeOfControl:(AGSegmentedControl *)control;
- (void)layoutSegments:(NSArray *)segments inControl:(AGSegmentedControl *)control;
- (void)drawBackgroundInRect:(NSRect)rect inControl:(AGSegmentedControl *)control;
- (void)drawSegmentsInRect:(NSRect)rect inControl:(AGSegmentedControl *)control;

// Required
- (BOOL)autoresizes;
- (void)drawSegment:(AGSegmentedCell *)segment position:(NSInteger)segmentIndex withFrame:(NSRect)frame inControl:(AGSegmentedControl *)control;

@end


@interface AGSegmentedStyleDelegate : NSObject {
	
}

@end




@class AGGradient;
@interface AGSegmentedSmallGrayStyle : AGSegmentedStyleDelegate
{
	AGGradient * normalFillGradient;
	AGGradient * pressedFillGradient;
	NSColor * disabledTopStrokeColor;
	NSColor * disabledBottomStrokeColor;
	NSColor * enabledTopStrokeColor;
	NSColor * enabledBottomStrokeColor;
	NSColor * pressedTopStrokeColor;
	NSColor * pressedBottomStrokeColor;
	NSColor * separatorStrokeColor;
}

@end



@interface AGSegmentedMetalStyle : AGSegmentedStyleDelegate {
	NSImage * mLeft;
	NSImage * mMiddle;
	NSImage * mRight;
	NSImage * mLeftDown;
	NSImage * mMiddleDown;
	NSImage * mRightDown;
	NSImage * mLeftDisabled;
	NSImage * mMiddleDisabled;
	NSImage * mRightDisabled;
	NSImage * mSeparator;
	NSImage * mSeparatorDown;
}

@end




@interface AGSegmentedAquaStyle : AGSegmentedStyleDelegate {
	
}

@end





@interface AGSegmentedSquareGradientStyle : AGSegmentedStyleDelegate {
	
	AGGradient * mNormalDisabledBottomHalfGradient;
	
	AGGradient * mNormalTopHalfGradient;
	AGGradient * mNormalBottomHalfGradient;
	AGGradient * mSelectedTopHalfGradient;
	AGGradient * mSelectedBottomHalfGradient;
	AGGradient * mHighlightedTopHalfGradient;
	AGGradient * mHighlightedBottomHalfGradient;
}

@end




@interface AGSegmentedToolbarStyle : AGSegmentedStyleDelegate
{
	NSColor * backgroundColor;
	NSColor * selectedBackgroundColor;
	NSColor * selectedBorderColor;
	NSColor * borderColor;
}

@end

