//
//  AGThreadSafeQueue.h
//  AraeliumFoundation
//
//  Based on WHThreadSafeQueue written by Keith Bauer
//  Keith is the man.
//

#import <Cocoa/Cocoa.h>

@interface AGThreadSafeQueue : NSObject
{
    NSConditionLock *lock;
    NSMutableArray  *queue;
	NSInteger unsafeSize;
	NSUInteger maximumCapacity;
}

- (id)init;
- (id)initWithMaximumCapacity:(NSUInteger)max;

- (BOOL)empty;
- (NSInteger)unsafeSize;

- (void)enqueue:(id)object;
- (id)dequeue;
- (id)dequeueBeforeDate:(NSDate *)date;

@end
