//
//  NSArrayAdditions.h
//  Queries
//
//  Created by Seth Willits on 7/29/08.
//  Copyright 2008 Araelium Group. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSArray (AraeliumAdditions)

- (id)firstObject;
- (id)objectWithValue:(id)value forKey:(NSString *)key;
- (NSUInteger)indexOfObjectWithValue:(id)value forKey:(NSString *)key;
- (NSIndexSet *)indexesOfObjectsInArray:(NSArray *)array;
- (NSIndexSet *)indexesOfObjectsInSet:(NSSet *)set;

- (NSArray *)arrayByRemovingObject:(id)object;

- (NSArray *)componentsEnclosedWith:(NSString *)encloser;

@end


//@interface NSMutableArray (AraeliumAdditions)
//
//+ (id)arrayWithCapacity:(NSUInteger)capacity prototype:(id)prototype;
//- (id)initWithCapacity:(NSUInteger)capacity prototype:(id)prototype;
//
//@end


@interface NSArray (AraeliumFoundationSortingAddition)

- (NSArray *)sortedArrayUsingKey:(NSString *)key ascending:(BOOL)ascending selector:(SEL)selector;

@end


